-- Farben.lua

print("Lua - Isch lech de Farwen fest")

rgb = function(r, g, b) return r + g * 0x100 + b * 0x10000 end

Farben =
	{
		SCHWARZ 		= 0x000000,
		WEISS 			= 0xFFFFFF,
		GRAU 			= 0x7F7F7F,
		HELLGRAU 		= 0xC0C0C0,
		WENIGHELLGRAU	= 0xB4B4B4,
		KAUMHELLGRAU	= 0xAAAAAA,
		DUNKELGRAU 		= 0x404040,
		DUNKELSTGRAU 	= rgb(16, 16, 16),
		DUNKLERGRAU 	= rgb(32, 32, 32),
		ECHTDUNKELGRAU 	= rgb(48, 48, 48), 
		OPAL			= rgb(112, 160, 176),
		FUELLFARBE1		= rgb(65, 79, 127),
		HELLERTEXT		= rgb(120, 120, 255),
		ZEITCURSOR		= 0x00FF00,
		ZEITRAHMEN		= 0x0000FF,
		HELLROT			= rgb(255, 0, 0),
		MUTEFARBE		= rgb(0, 0, 64),
		SOLOFARBE		= rgb(64, 64, 0),
		HELLGRUEN		= rgb(0, 255, 0),
		HELLBLAU		= rgb(0, 0, 255),
		HELLGELB		= rgb(255, 255, 0),
		HELLERGELB		= rgb(140, 140, 0),
		LEICHTORANGE	= rgb(217, 180, 90),
		GELB			= rgb(128, 128, 0),
		ORANGE			= rgb(255, 180, 0),
		WEISSROT		= rgb(255, 127, 127),
		VIOLETT			= rgb(128, 32, 176),
		MEHRGRUEN		= rgb(0, 192, 0), 
		MEHRBLAU		= rgb(0, 0, 192),
		MAGENTA			= rgb(128, 0, 128),
		KAUMMEHRGRUEN	= rgb(50, 90, 60),
		WEISSNICHTBLAU	= rgb(200, 200, 255),
		POSITIONSFARBE	= rgb(240, 240, 177),
		SIGNALGELB      = rgb(180, 255, 128),
		SIGNALROT       	= rgb(255, 180, 128),
		NOTENHINTERGRUND 	= rgb(200, 255, 200),
		NOTENFARBE       	= rgb(55, 0, 55),
		GESPERRT			= rgb(10, 20, 50),
		ROTBRAUN			= rgb(128, 64, 0)
	}

Farbe = function(x) return Farben[x] end

-- 158 158  30  RGB new-color ETWASHELLERGELB		\ FarbePitchbend
 --  		// Lokatorschleifenhintergrund
  -- 0   0  64  RGB new-color DUNKELBLAU
 -- 64  64   0  RGB new-color DUNKELGELB
-- 205 205 177  RGB new-color HALBWEISSGELB
-- 100 100 140  RGB new-color GRAUNICHTBLAU
 -- 16  16  16  RGB new-color DUNKELSTGRAU
 -- 32  32  32  RGB new-color DUNKLERGRAU
 -- 48  48  48  RGB new-color ECHTDUNKELGRAU
-- 127 255 127  RGB new-color WEISSGRUEN 			// FarbeProgram
-- 167 167 255  RGB new-color WEISSBLAU 			// FarbeControl
-- 255 127 255  RGB new-color WEISSMAGENTA			// FarbeTimeSignat
-- 198 134 182	 RGB new-color HELLWEINROT			// FarbeKey&ChanPress
-- 
-- 
-- 103  79 127  RGB new-color ANZEIGENFLLFARBE
 -- 88 109 112  RGB new-color ANZEIGENFLLFARBE_v1
-- 118  49 142  RGB new-color ANZEIGENFLLFARBE_v2
 -- 73  79 142  RGB new-color ANZEIGENFLLFARBE_v3
-- 118  79  97  RGB new-color ANZEIGENFLLFARBE_v4
-- 
 -- 65  75 127  RGB new-color DEFAULTFLLFARBE
 -- 60 140  50  RGB new-color TERTIRERAHMENFARBE
-- 200 255 200  RGB new-color NOTENHINTERGRUND
 -- 55   0  55  RGB new-color NOTENFARBE
-- 
-- 
-- // #define DefaultRahmenfarbe                      RGB(50,   190, 200)
-- // #define SekundaereRahmenfarbe                   RGB(110,  170,  120)
-- 
-- : Statusfarbe ( Status -- ColorObj )
	-- WHITE swap
	-- dup $7F > over $F0 < and IF $F0 and THEN
	-- CASE
		-- StatMarker		OF drop FARBEMARKER		ENDOF
		-- StatLyrics		OF drop FARBELYRICS		ENDOF
		-- StatTimeSignat	OF drop WEISSMAGENTA	ENDOF
		-- StatKeySignat	OF drop LTCYAN			ENDOF
		-- StatSetTempo	OF drop WEISSROT		ENDOF
		-- StatKeyOff 		OF drop LEICHTORANGE 	ENDOF
		-- StatKeyOn  		OF drop ORANGE 			ENDOF
		-- StatProgram 	OF drop WEISSGRUEN 		ENDOF
		-- StatControl 	OF drop WEISSBLAU 		ENDOF
		-- StatPitch		OF drop ETWASHELLERGELB	ENDOF
		-- StatSetTempo	OF drop WEISSROT		ENDOF
		-- StatSongSelect	OF drop HELLGELB		ENDOF
		-- StatStartPlay	OF drop HELLGELB		ENDOF
		-- StatStopPlay	OF drop HELLGELB		ENDOF
		-- StatChnPressure OF drop HELLWEINROT		ENDOF
		-- StatKeyPressure OF drop HELLWEINROT		ENDOF
	-- ENDCASE
-- ;
-- 
-- : Intensittsfarbe ( colorobj fs: Anteil -- ) { \ rot grn blau -- }
        -- 500e fmin 0e fmax fdup f# 500 f* f>s f0.5 f<
        -- IF
                -- 0 to rot
                -- dup to grn
                -- 250 swap - to blau
        -- ELSE
                -- dup 250 - to rot
                -- 500 swap - to grn
                -- 0 to blau
        -- THEN
        -- rot grn blau RGB newcolor: [ swap ]
-- ;
-- 
-- : Spektralfarbe ( colorobj fs: Anteil -- ) { \ rot grn blau -- }
        -- 1e fmin 0e fmax fdup f# 500 f* f>s f0.5 f<
        -- IF
                -- 0 to rot
                -- to grn
                -- 0 to blau
        -- ELSE
                -- dup 250 - to rot
                -- 500 swap - to grn
                -- 0 to blau
        -- THEN
        -- rot grn blau RGB newcolor: [ swap ]
-- ;
-- 
-- : Farbmodifikation ( r g b COLORREF colorobj -- ) { \ r1 g1 b1 -- }
	-- >r
	-- dup $FF and to r1 dup $FF00 and 8 rshift to g1 $FF0000 and 16 rshift to b1
	-- rot r1 + 0max 255 min -rot swap g1 + 0max 255 min swap b1 + 0max 255 min
	-- RGB NewColor: [ r> ]
-- ;
-- 
-- : Farbverbindung ( COLORREF COLORREF colorobj fs: Mix -- ) { \ r1 r2 g1 g2 b1 b2 -- }
	-- >r
	-- 2dup $FF and to r2 $FF and to r1
	-- 2dup $FF00 and 8 rshift to g2 $FF00 and 8 rshift to g1
	-- $FF0000 and 16 rshift to b2 $FF0000 and 16 rshift to b1
 	-- r1 s>f fover f* fover 1e fswap f- r2 s>f f* f+ f>s 255 min
 	-- g1 s>f fover f* fover 1e fswap f- g2 s>f f* f+ f>s 255 min
	-- b1 s>f fover f* fover 1e fswap f- b2 s>f f* f+ f>s 255 min fdrop
	-- RGB NewColor: [ r> ]
-- ;

Statusfarben = {}
Statusfarben[0x01] = rgb(128, 128, 160)
Statusfarben[0x05] = rgb(112, 160, 176)
Statusfarben[0x06] = rgb(180, 255, 128)
Statusfarben[0x80] = rgb(217, 180, 90)
Statusfarben[0x90] = rgb(255, 180, 0)
Statusfarben[0xA0] = rgb(178, 114, 162)
Statusfarben[0xB0] = rgb(127, 127, 255)
Statusfarben[0xC0] = rgb(127, 255, 127)
Statusfarben[0xD0] = rgb(178, 114, 162)
Statusfarben[0xE0] = rgb(148, 148, 20)
Statusfarben[0xF3] = rgb(235, 220, 0)
Statusfarben[0xFA] = rgb(235, 220, 0)
Statusfarben[0xFC] = rgb(235, 220, 0)
Statusfarben[0x51] = rgb(255, 127, 127)
Statusfarben[0x58] = rgb(255, 127, 255)
Statusfarben[0x59] = rgb(0, 255, 255)

Statusfarbe = function(x) 
	a = Statusfarben[x] 
	if a == nil then a = 0x7F7F7F end
	return a 
end


-- // FARBE_BREATH          Controllerfarben 2  cells+ !
-- // FARBE_FOOT            Controllerfarben 4  cells+ !
-- // FARBE_DETUNE          Controllerfarben 94 cells+ !
-- 144 187 235  RGB new-color FARBE_BREATH
-- 144 128 192  RGB new-color FARBE_FOOT
-- 200  11  44  RGB new-color FARBE_DETUNE
-- 
-- \ #define FarbeResonance     RGB(137, 107, 145)
-- \ #define FarbeLPF           RGB(30,  20,  128)
-- \ #define FarbeHPF           RGB(128, 30,  20)
-- \ #define FarbeReverb        RGB(200, 200, 255)
-- \ #define FarbeChorus        RGB(255, 200, 200)
-- \ #define FarbeTremolo       RGB(200, 255, 200)
-- \ #define FarbePhaser        RGB(188, 100, 0)
Controllerfarben = {}
Controllerfarben[0x01] = rgb(127, 127, 255)
Controllerfarben[0x07] = rgb(221, 222, 229)
Controllerfarben[0x08] = rgb(190, 220, 229)
Controllerfarben[0x0A] = rgb(158, 178, 250)
Controllerfarben[0x0B] = rgb(200,  82, 200)
Controllerfarben[44] = rgb(100, 20, 20)
Controllerfarben[45] = rgb(20, 100, 20)
Controllerfarben[46] = rgb(20, 20, 100)

Controllerfarbe = function(x) 
	a = Controllerfarben[x] 
	if a == nil then a = 0x7F7F7F end
	return a 
end

